% Joe Jupin
% Homework 2

%  clear all variables
clear all;

%  read image
I = imread('phaser1.jpg');
% convert to grayscale
I1 = rgb2gray(I);
% set image output to gray
colormap(gray);
% show unprocessed image
imshow(I1);

% compute histogram
H = double(zeros(256,1));
for i=1:numel(I1)
    H(double(I1(i))+1) = H(double(I1(i))+1) + 1;
end
% show image histogram
figure, bar(H);

% calculate probabilities of histogram
P = double(zeros(256,1));
for i=1:256
    P(i) = H(i)/numel(I1);
end

% calculate summation of Pi's
S = double(zeros(256,1));
S(1) = P(1);
for i=2:256
    S(i) = P(i) + S(i-1);
end

% calculate T
T = double(zeros(256,1));
for i=1:256
    T(i) = 255*S(i);
end

% transform old image to new image
I2 = I1;
for i=1:numel(I1)
    I2(i) = T(double(I1(i))+1);
end
% show new image
figure, imshow(I2);

% compute new image histogram
H1 = double(zeros(256,1));
for i=1:numel(I2)
    H1(double(I2(i))+1) = H1(double(I2(i))+1) + 1;
end
% show new image histogram
figure, bar(H1);