% Joe Jupin
% Homework 2

%  clear all variables
clear all;

%  read image
I = imread('phaser2.jpg');
% convert to grayscale
I = rgb2gray(I);
% set image output to gray
colormap(gray);
% show unprocessed image
imshow(I);

% compute histogram
H = double(zeros(256,1));
for i=1:numel(I)
    H(double(I(i))+1) = H(double(I(i))+1) + 1;
end
% show image histogram
figure, bar(H);

% calculate transformation array
H(1) = 255*H(1)/numel(I);
for i=2:256
    H(i) = 255*H(i)/numel(I) + H(i-1);
end

% transform old image to new image
for i=1:numel(I)
    I(i) = H(double(I(i))+1);
end
% show new image
figure, imshow(I);

% compute new image histogram
H = double(zeros(256,1));
for i=1:numel(I)
    H(double(I(i))+1) = H(double(I(i))+1) + 1;
end
% show new image histogram
figure, bar(H);